#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: backup_support.pl, v2.0.0-1 Fri 28 Oct 2011 11:19:30 PM CEST mstauber Exp $
# Copyright 2006-2011 Stauber Multimedie Design. All rights reserved.

# This constructor / handler checks if we support vzdump as backup method and if 
# we can do snapshots, or if we have to use suspend instead.

$whatami = "constructor";

use CCE;
my $cce = new CCE;

if ($whatami eq "handler") {
    $cce->connectfd();
}
else {
    $cce->connectuds();
}

# Do the deeds:
&main;

$cce->bye('SUCCESS');
exit(0);

##
# Subs:
##

# Do the deeds:
sub main {
    $vzdump_backup_type = "0";

    # Do we have the free LVM partition /var/freespace?
    $vzdump_available = "0";
    $info = `cat /etc/fstab |grep /var/freespace`;
    if (length($info) > "0") {
	$vzdump_available = "1";
    }

    # Do we have a separate non-LVM partition onto which to store the backups?
    $backup_part_available = "0";
    $b_info = `cat /etc/fstab |grep /backup`;
    if (length($b_info) > "0") {
	$backup_part_available = "1";
	$vzdump_backup_type = "1";
    }

    # If both are the case, then we can use 'vzdump' in snapshot mode:
    $vzdump_backup_type = "0";
    if (($vzdump_available == "1") && ($backup_part_available == "1")) {
	$vzdump_backup_type = "1";
    }

    # Push settings to CODB:
    @oids = $cce->find('VserverMasterNode');
    ($ok) = $cce->set($oids[0], '',{ 
					'vzdump_available' => $vzdump_available,
					'backup_part_available' => $backup_part_available,
					'vzdump_backup_type' => $vzdump_backup_type
				    });
}

$cce->bye('SUCCESS');
exit(0);
